#pragma once

#include "stdafx.h"
#include <btBulletDynamicsCommon.h> // Bulletpwb_[t@C

class CMouseView
{
public:
    CMouseView(void);
    ~CMouseView(void);

    // r[EvWFNVigpj
    GLint viewport[4];
    GLfloat modelview[16];
    GLfloat projection[16];
    GLfloat aspect;
    GLfloat fovy;
    GLfloat zNear;
    GLfloat zFar;

    // _̈ʒuE_ExNg
    btVector3       m_vPosition;
    btVector3       m_vTarget;
    btVector3       m_vUp;
    btVector3       m_vRight;
    // _̎p
    btQuaternion    m_qRotation;
    btMatrix3x3     m_mRotation;
    // _̈ʒupigpj
    btTransform     m_tTransform;

    // }EX̃NbNWۑp
    GLint startPos[3][2], backPos[2];
    // }EX̃{^ۑp
    BOOL onButton[3];

    // }EX̃C֌W
    GLfloat centerPos[3];
    GLfloat clickPos[3];
    GLfloat realHeight, realWidth;
    GLfloat dx, dy, width, height;
    btVector3 m_vDir;

    // _̈ʒuE_ExNg
    GLfloat eye[3];
    GLfloat center[3];
    GLfloat up[3];

    // ̂Ƃ떢gp
    void setPerspective(GLfloat fov, GLfloat as, GLfloat n, GLfloat f);
    void setViewport(int x, int y, int w, int h);
    // }EX
    void mouse(int button, int state, int x, int y);
    void motion(int x, int y);
    // JWnvZ
    void calculateCameraMatrix(btVector3 &position, btVector3 &target);

    // NbN[hWvZ
	void calculatePoint(int x, int y, double pos[3]);
    // Cł߂_̃CfbNXvZ
    int rayNearestPoint(double rayOrg[3], double rayDelta[3], GLfloat **pos, int point_num, float maxT);

    // _̍XV
    void update();
};
